#include <stdio.h>
#include <stdlib.h>

typedef struct Actor
{
int x;
int y;
} Actor;

typedef struct Node
{
Actor act;
struct Node* next;
} Node;

Node root;

int findNodeCount()
{
int nodecount = 0;
for (Node* curnode = &root; curnode != NULL; curnode = curnode->next)
{
nodecount++;
}
return nodecount;
}

int findNode(int index)
{
Node* curnode = &root;
for (int i = 0; i < index; i++)
{
if (curnode->next != NULL)
{
curnode = curnode->next;
}
else
{
break;
}
}
return curnode->act.x;
}

void appendNode(int newx)
{
Node* curnode = &root;
while (curnode->next != NULL)
{
curnode = curnode->next;
}
curnode->next = malloc(sizeof(Node));
curnode->next->act.x = newx;
}

void insertNode(int index, int newx)
{
Node* curnode = &root;
index--;
for (int i = 0; i < index; i++)
{
if (curnode->next != NULL)
{
curnode = curnode->next;
}
else
{
break;
}
}
Node* newnode = malloc(sizeof(Node));
newnode->act.x = newx;
newnode->next = curnode->next;
curnode->next = newnode;
}

void destroyNode(int index)
{
Node* curnode = &root;
Node* delnode = NULL;
index = (index > findNodeCount()) ? findNodeCount() - 2 : index;
for (int i = 0; i < index; i++)
{
if (curnode->next != NULL)
{
curnode = curnode->next;
}
else
{
break;
}
}
if (curnode->next != NULL)
{
delnode = curnode->next;
curnode->next = curnode->next->next;
}
free(delnode);

}

int main()
{

root.act.x = 3;

// append 2 nodes to the list
appendNode(-2);
appendNode(5);

// insert a new node under the head
insertNode(0, 19);

for (int i = 0; i < findNodeCount(); i++)
{
printf("%d\n", findNode(i));
}

printf("%d Nodes Found\n", findNodeCount());

// destroy the node we created
destroyNode(0);

for (int i = 0; i < findNodeCount(); i++)
{
printf("%d\n", findNode(i));
}

printf("%d Nodes Found\n", findNodeCount());

return 0;
}